package htdp;

import procedures.orderings.StrOrder;
import structures.basic.Str;
import structures.list.Empty;
import structures.set.OrderedSet;
import types.structures.IList;
import types.structures.ISet;

public class DrScheme {

	// Produces the set of all keywords in DrScheme's first language level.
	public static ISet keywords() {
		return
			new OrderedSet(new StrOrder())
				.insert(new Str("(")).insert(new Str(")"))
				.insert(new Str("define")).insert(new Str("define-struct"))
				.insert(new Str("cond")).insert(new Str("else"))
				.insert(new Str("and")).insert(new Str("or"));
	}
	
	// Produces a token list (IList of Str) from an input String.
	public static IList tokenList( String program ) {
		IList result = new Empty();
		String[] tokens = program.split(" +");
		int i = tokens.length - 1;
		
		while( i >= 0 ) {
			result = result.cons(new Str(tokens[i]));
			i = i - 1;
		}
		return result;
	}
	
}
