package procedures.combinations;

import types.procedures.ICombine;
import types.procedures.ISelect;

// Represents a conditional combination.
public class CombineIf implements ICombine {

	public ISelect predicate;
	public ICombine join;
	
	public CombineIf( ISelect predicate, ICombine join ) {
		this.predicate = predicate;
		this.join = join;
	}
	
	// Joins input with previous if input satisfies predicate.
	public Object combine(Object input, Object previous) {
		if ( predicate.select(input) ) {
			return join.combine(input, previous);
		} else {
			return previous;
		}
	}

}
