package structures.basic;

import types.structures.ISame;

// Represents a string (implementing ISame)
public class Str implements ISame {
	
	public String value;
	
	public Str( String value ) {
		this.value = value;
	}

	// Tells whether this is the same as that.
	public boolean same(ISame that) {
		return this.equals(that);
	}
	
	// Produces a valid hashcode number.
	public int hashCode() {
		return value.hashCode();
	}
	
	// Tells whether this is the same as that.
	public boolean equals( Object obj ) {
		return obj instanceof Str && this.value.equals(((Str)obj).value);
	}
	
	// Produces a string for displaying this.
	public String toString() {
		return "\"" + this.value + "\"";
	}

}
