package structures.list;

import types.structures.IList;
import types.structures.ISame;

// Represents a list constructed from element and subsequent list.
public class Cons extends AList {

	public Object first;
	public AList rest;
	
	public Cons( Object car, AList cdr ) {
		this.first = car;
		this.rest = cdr;
	}

	// Tells whether this is the same as that.
	public boolean same( ISame that ) {
		if ( that instanceof IList ) {
			IList list = (IList)that;
			return
				!list.isEmpty() &&
				((ISame)this.first).same((ISame)list.getFirst()) &&
				this.rest.same(list.getRest());
		} else {
			return false;
		}
	}
	
	// Tells that this is not empty.
	public boolean isEmpty() {
		return false;
	}

	// Produces first element of this.
	public Object getFirst() {
		return this.first;
	}

	// Produces rest of this.
	public IList getRest() {
		return this.rest;
	}
	
	// Produces length of list.
	public int length() {
		return 1 + rest.length();
	}

}
