package structures.list;

import types.structures.IList;
import types.structures.ISame;
import exceptions.EmptyListException;

// Represents an empty list.
public class Empty extends AList {

	public Empty() {}

	// Tells whether this is the same as that.
	public boolean same( ISame that ) {
		return that instanceof IList && ((IList)that).isEmpty();
	}
	
	// Tells that this is empty.
	public boolean isEmpty() {
		return true;
	}

	// Throws EmptyListException (empty has no first element).
	public Object getFirst() {
		throw new EmptyListException();
	}

	// Throws EmptyListException (empty has no rest).
	public IList getRest() {
		throw new EmptyListException();
	}
	
	// Produces the length of the list.
	public int length() {
		return 0;
	}

}
