package structures.tree;

import types.structures.ISame;
import types.structures.ITree;
import exceptions.LeafTreeException;

// Represents the leaf of a binary tree
public class Leaf extends ATree {

	public Leaf() {}
	
	// Tells whether this is the same as that.
	public boolean same( ISame that ) {
		return that instanceof ITree && ((ITree)that).isLeaf();
	}
	
	// Produces the height of this
	public int getHeight() {
		return 0;
	}

	// Tells that this is a leaf
	public boolean isLeaf() {
		return true;
	}

	// Throws LeafTreeException (no data stored in leaf)
	public Object getData() {
		throw new LeafTreeException();
	}

	// Throws LeafTreeException (no left child of a leaf)
	public ITree getLeft() {
		throw new LeafTreeException();
	}

	// Throws LeafTreeException (no right child of a leaf)
	public ITree getRight() {
		throw new LeafTreeException();
	}
	
	// Produces a string to display this.
	public String toString() {
		return "leaf";
	}

}
