package types.structures;

// ILists represent ordered sets of objects.
public interface IList extends ISame {

	// Tells whether the list contains any elements.
	public boolean isEmpty();
	
	// Produces a copy of the list with element at the front.
	public IList cons(Object element);
	
	// Produces the first element in the list or throws EmptyListException.
	public Object getFirst();
	
	// Produces the list of elements after the first or throws EmptyListException.
	public IList getRest();
	
	// Produces the length of the list.
	public int length();
	
}
