package types.structures;

// IMaps represent mappings from keys to values.
public interface IMap {

	// Tells whether a mapping has values for any keys.
	public boolean isEmpty();
	
	// Tells whether a mapping has a value for a specific key.
	public boolean contains( ISame key );
	
	// Produces the value for a specific key or throws NotFoundException.
	public Object lookup( ISame key );

	// Produces a copy of the mapping with key mapped to value.
	public IMap extend( ISame key, Object value );
	
	// Produces all the keys in the mapping.
	public IList keys();
	
	// Produces all the values in the mapping.
	public IList values();
	
	// Produces all the key/value pairs (of class Entry) in the mapping.
	public IList entries();
	
}
