package types.structures;

// Represents a binary tree.
public interface ITree extends ISame {
	
	// Calculates the height of a tree (distance to a leaf)
	public int getHeight();
	
	// Tells whether tree is a leaf.
	public boolean isLeaf();
	
	// Produces data stored in a node or throws LeafTreeException.
	public Object getData();
	
	// Produces node's left child or throws LeafTreeException.
	public ITree getLeft();
	
	// Produces node's right child or throws LeafTreeException.
	public ITree getRight();
	
	// Produces node with this as left child.
	public ITree hangLeft( Object data, ITree rightChild );
	
	// Produces node with this as right child.
	public ITree hangRight( ITree leftChild, Object data );

}
